//----------------------------------------------------------------------//
// CapStick																//
//	CtH[														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <math.h>
#include <mmsystem.h>
#include <Winapi.ShellAPI.hpp>
#include <Vcl.Clipbrd.hpp>
#include <Vcl.Imaging.jpeg.hpp>

#include <Vcl.HtmlHelpViewer.hpp>
#pragma link "Vcl.HTMLHelpViewer"

#include "usr_wic.h"
#include "UserFunc.h"
#include "Unit1.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCapStickForm *CapStickForm;

//--------------------------------------------------------------------------
//W}EXJ[\Xg
TCursor CsrTable[MAX_STD_CSR] = {
	crArrow,
	crCross,
	crIBeam,
	crUpArrow,
	crSizeNESW,
	crSizeNS,
	crSizeNWSE,
	crSizeWE,
	crSizeAll,
	crNo,
	crHourGlass,
	crDrag,
	crNoDrop,
	crHSplit,
	crVSplit,
	crMultiDrag,
	crSQLWait,
	crAppStart,
	crHelp,
	crHandPoint
	};

//--------------------------------------------------------------------------
__fastcall TCapStickForm::TCapStickForm(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TCapStickForm::FormCreate(TObject *Sender)
{
	VersionNo = get_VersionNo();

	ImgBuff  = new Graphics::TBitmap();
	UndoList = new TStringList();

	//wvt@C
	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");

	//ݒ̓Ǎ
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	UnicodeString sct = "General";
	int lst_vno = IniFile->ReadInteger(sct,"Version",0);
	if (lst_vno<VersionNo) IniFile->WriteInteger(sct,"Version", VersionNo);

	LastDir    = IniFile->ReadString(sct, "LastDir", 	EmptyStr);
	LastDefExt = IniFile->ReadString(sct, "LastDefExt",	"BMP");
	LastCurDir = IniFile->ReadString(sct, "LastCurDir",	EmptyStr);

	ImgBgCol = (TColor)IniFile->ReadInteger(sct,"ImgBgColor",clBlack);
	ScrollBox1->Color = ImgBgCol;

	sct = "Option";
	HideWait	 = IniFile->ReadInteger(sct, "HideWait",	100);
	CaptureWait  = IniFile->ReadInteger(sct, "CaptureWait",	3000);
	JpegQuality  = IniFile->ReadInteger(sct, "JpegQuality",	100);
	ScaleOpt	 = IniFile->ReadInteger(sct, "ScaleOpt",	0);
	ExtAllIcon	 = IniFile->ReadBool(   sct, "ExtAllIcon",	true);

	sct = "Sound";
	SoundCapImg = get_filename_r(IniFile->ReadString(sct, "CapImage", EmptyStr));
	SoundChgImg = get_filename_r(IniFile->ReadString(sct, "ChgImage", EmptyStr));

	sct = "OnCopy";
	CopyActWndClass  = IniFile->ReadString(sct, "ActWndClass", EmptyStr);
	CopyActWndTitle  = IniFile->ReadString(sct, "ActWndTitle", EmptyStr);
	CopyActWndTitleR = IniFile->ReadString(sct, "ActWndTitleR", EmptyStr);
	CopyCmdLine 	 = IniFile->ReadString(sct, "CmdLine", EmptyStr);
	CopySendKey 	 = IniFile->ReadString(sct, "SendKey", EmptyStr);

	sct = "OnSave";
	SaveCmdLine = IniFile->ReadString(sct, "CmdLine", EmptyStr);

	crCapture = (TCursor)5;	//ߊl̏J[\
	crPaste   = (TCursor)6;	//\tJ[\
	Screen->Cursors[crCapture] = ::LoadCursor(HInstance, _T("CAPTURE"));

	Capturing  = false;
	Selecting  = false;
	SelMoving  = false;
	CsrPasting = false;
	hCurWnd    = NULL;

	for (unsigned int i=0; i<MAX_STD_CSR; i++) {
		TMenuItem *mp = new TMenuItem(MouseCsrItem);
		mp->Caption   = EmptyStr;
		mp->Tag = (int)CsrTable[i];
		if (i==10) mp->Break = mbBarBreak;
		mp->OnClick 	  = CsrPasteItemClick;
		mp->OnDrawItem	  = MouseCsrItemDrawItem;
		mp->OnMeasureItem = MouseCsrItemMeasureItem;
		MouseCsrItem->Add(mp);
	}

	::DragAcceptFiles(Handle, true);
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::FormShow(TObject *Sender)
{
	if (!Capturing) {
		//EBhE̕\Ԃ𕜌
		load_form_pos(this, IniFile, 220,240);

		UnicodeString sct = "General";
		ClsNamPanel->Visible = IniFile->ReadBool(sct, "ShowClsName", true);
		WndTxtPanel->Visible = IniFile->ReadBool(sct, "ShowWndText", true);
		ColValFmt			 = IniFile->ReadInteger(sct, "ColValFmt", 0);
		PixColPanel->Visible = (ColValFmt>0);
		StatusBar1->Visible  = IniFile->ReadBool(sct, "ShowSttBar",  true);
		MrkImageList->GetBitmap(1, CapToolImg->Picture->Bitmap);

		//}EXJ[\Lv`[c[̈ʒu
		TPoint p = CapToolPanel->ClientToScreen(
			Point(CapToolPanel->Width/2, CapToolPanel->Height/2));
		::SetCursorPos(p.x, p.y);
	}
}

//---------------------------------------------------------------------------
void __fastcall TCapStickForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	//ݒۑ
	save_form_pos(this, IniFile);

	UnicodeString sct = "General";
	IniFile->WriteBool(   sct, "ShowClsName",	ClsNamPanel->Visible);
	IniFile->WriteBool(   sct, "ShowWndText",	WndTxtPanel->Visible);
	IniFile->WriteBool(   sct, "ShowSttBar",	StatusBar1->Visible);
	IniFile->WriteString( sct, "LastDir", 		LastDir);
	IniFile->WriteString( sct, "LastDefExt",	LastDefExt);
	IniFile->WriteString( sct, "LastCurDir",	LastCurDir);
	IniFile->WriteInteger(sct, "ImgBgColor",	(int)ImgBgCol);

	IniFile->WriteInteger(sct, "ColValFmt",		ColValFmt);

	sct = "Option";
	IniFile->WriteInteger(sct, "HideWait",		HideWait);
	IniFile->WriteInteger(sct, "CaptureWait",	CaptureWait);
	IniFile->WriteInteger(sct, "JpegQuality",	JpegQuality);
	IniFile->WriteInteger(sct, "ScaleOpt",		ScaleOpt);
	IniFile->WriteBool(   sct, "ExtAllIcon",	ExtAllIcon);

	sct = "Sound";
	IniFile->WriteString( sct, "ChgImage",		SoundChgImg);
	IniFile->WriteString( sct, "CapImage",		SoundCapImg);

	sct = "OnCopy";
	IniFile->WriteString( sct, "ActWndClass",	CopyActWndClass);
	IniFile->WriteString( sct, "ActWndTitle",	CopyActWndTitle);
	IniFile->WriteString( sct, "ActWndTitleR",	CopyActWndTitleR);
	IniFile->WriteString( sct, "CmdLine",		CopyCmdLine);
	IniFile->WriteString( sct, "SendKey",		CopySendKey);

	sct = "OnSave";
	IniFile->WriteString( sct, "CmdLine",		SaveCmdLine);
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::FormDestroy(TObject *Sender)
{
	delete ImgBuff;
	delete IniFile;
}

//---------------------------------------------------------------------
// t@C̃hbv
//---------------------------------------------------------------------
void __fastcall TCapStickForm::WMDropFiles(TWMDropFiles &message)
{
	UINT filecount = ::DragQueryFile((HDROP)message.Drop, 0xFFFFFFFF, NULL, 0);

	if (filecount>0) {
		SelRect = Rect(0,0,0,0);
		UnicodeString fnam;
		fnam.SetLength(MAX_PATH);
		int len = ::DragQueryFile((HDROP)message.Drop,0, fnam.c_str(), fnam.Length());
		fnam.SetLength(len);
		bool flag = true;

		if (!WIC_load_image(fnam, ImgBuff)) {
			ScrollBox1->HorzScrollBar->Range = ScrollBox1->ClientWidth;
			ScrollBox1->VertScrollBar->Range = ScrollBox1->ClientHeight;
			Graphics::TBitmap *bp = Image1->Picture->Bitmap;
			bp->SetSize(Image1->ClientWidth, Image1->ClientHeight);
			Image1->Canvas->Brush->Color = ImgBgCol;
			Image1->Canvas->FillRect(Image1->ClientRect);
			//ACRo
			int ixn = (int)::ExtractIcon(HInstance, fnam.c_str(), -1);
			//擾(.exeA.dll A.ico)
			if (ixn>0) {
				if (!ExtAllIcon) ixn = 1;
				int x = 0;
				int y = 0;
				int w,h;
				bp->SetSize(32, 32);
				for (int i=0; i<ixn; i++) {
					std::unique_ptr<Graphics::TIcon> icn(new Graphics::TIcon());
					icn->Handle = ::ExtractIcon(HInstance, fnam.c_str(), i);
					if (icn->Handle) {
						w = icn->Width;
						h = icn->Height;
						if (bp->Width<x+w)  bp->Width  = x+w;
						if (bp->Height<y+h) bp->Height = y+h;
						Image1->Canvas->FillRect(Rect(x,y,x+w,y+h));
						::DrawIcon(Image1->Canvas->Handle, x, y, icn->Handle);
						::DestroyIcon(icn->Handle);
						if ((x+2*w)>Image1->ClientWidth) {
							x = 0; y += h;
						}
						else
							x += w;
					}
				}
				if (ixn>1) SelRect = Rect(0,0,w,h);
				ImgBuff->Assign(bp);
			}
			//̑̃t@C
			else {
				SHFILEINFO sif;
				if (::SHGetFileInfo(fnam.c_str(), 0, &sif, sizeof(SHFILEINFO), SHGFI_ICON|SHGFI_LARGEICON) != 0) {
					bp->SetSize(32, 32);
					::DrawIcon(Image1->Canvas->Handle, 0, 0, sif.hIcon);
					ImgBuff->Assign(bp);
				}
				else flag = false;
			}
		}

		if (flag) {
			DrawImgBuff();
			if (!SoundCapImg.IsEmpty()) ::sndPlaySound(SoundCapImg.c_str(), SND_ASYNC);
		}

		SetSelRect();
	}

	::DragFinish((HDROP)message.Drop);
	::SetForegroundWindow(Handle);
}

//---------------------------------------------------------------------------
//AhD̒ǉ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::AddUndo()
{
	Graphics::TBitmap *bp = new Graphics::TBitmap();
	bp->Assign(ImgBuff);
	UndoList->InsertObject(0, EmptyStr, (TObject*)bp);

	while (UndoList->Count>MAX_UNDO_CNT) {
		int idx = UndoList->Count-1;
		Graphics::TBitmap *bp = (Graphics::TBitmap *)UndoList->Objects[idx];
		delete bp;
		UndoList->Delete(idx);
	}
}

//---------------------------------------------------------------------------
//摜񓙂̕\
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::DispInfo()
{
	UnicodeString tmpstr;
	//Ig̈ʒuƃTCY
	if (SelShape->Visible && !SelRect.IsEmpty()) {
		tmpstr = SelMoving? "ړ " : "I ";
		tmpstr.cat_sprintf(_T("(%4d,%4d-%4d,%4d) : (%3d~%3d)"),
			SelRect.Left, SelRect.Top, SelRect.Right, SelRect.Bottom, SelRect.Width(), SelRect.Height());
	}
	//摜
	else if (!ImgBuff->Empty) {
		tmpstr.sprintf(_T("摜TCY: %4d ~%4d "), ImgBuff->Width, ImgBuff->Height);
		switch (ImgBuff->PixelFormat) {
		case  pf1bit: tmpstr.UCAT_TSTR("(mN)"); break;
		case  pf4bit: tmpstr.UCAT_TSTR("(16F)");	  break;
		case  pf8bit: tmpstr.UCAT_TSTR("(256F)");	  break;
		}
	}
	StatusBar1->SimpleText = tmpstr;
}

//---------------------------------------------------------------------------
//ImgBuffʂɕ`
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::DrawImgBuff()
{
	Image1->Picture->Bitmap->SetSize(ImgBuff->Width, ImgBuff->Height);
	Image1->Canvas->Draw(0,0, ImgBuff);
	ScrollBox1->HorzScrollBar->Range = ImgBuff->Width;
	ScrollBox1->VertScrollBar->Range = ImgBuff->Height;
	DispInfo();
	Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
//Ig̍XV
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SetSelRect()
{
	TRect rc = SelRect;
	rc.Offset(-ScrollBox1->HorzScrollBar->Position, -ScrollBox1->VertScrollBar->Position);
	SelShape->BoundsRect = rc;
	SelShape->Visible = !SelRect.IsEmpty();
	DispInfo();
}

//---------------------------------------------------------------------------
//wEBhẼLv`[
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CaptWndImg(HWND hw)
{
	if (!hw) return;

	//NXу^Cg擾ĕ\
	_TCHAR strbuf[256];
	::GetClassName(hw, strbuf, 255);
	ClsNamEdit->Text = strbuf;
	::GetWindowText(hw, strbuf, 255);
	WndTxtEdit->Text = strbuf;

	//荞ݏ
	Image1->Canvas->Brush->Color = ImgBgCol;
	Image1->Canvas->FillRect(Image1->ClientRect);
	RECT rc;
	::GetWindowRect(hw, &rc);

	if (Screen->MonitorCount==1) {
		//1ʂ̏ꍇAʊO͏O
		if (rc.left<0) rc.left = 0;
		if (rc.top<0)  rc.top  = 0;
		if (rc.right>Screen->Width)   rc.right	= Screen->Width;
		if (rc.bottom>Screen->Height) rc.bottom = Screen->Height;
	}
	int w = rc.right - rc.left;
	int h = rc.bottom - rc.top;
	if (w<=0 || h<=0) return;

	ScrollBox1->HorzScrollBar->Range = w;
	ScrollBox1->VertScrollBar->Range = h;
	Image1->Picture->Bitmap->SetSize(w, h);
	Image1->Canvas->Brush->Color = ImgBgCol;
	Image1->Canvas->FillRect(Image1->ClientRect);

	//EBhE[W擾
	HRGN hWrgn = ::CreateRectRgn(0,0,w,h);
	::GetWindowRgn(hw, hWrgn);
	//ʂ荞
	HDC ImgDc = Image1->Canvas->Handle;
	::SelectClipRgn(ImgDc, hWrgn);
	HDC scr_dc = ::CreateDC(_T("DISPLAY"), NULL, NULL, NULL);
	::BitBlt(ImgDc, 0,0,w,h, scr_dc, rc.left,rc.top, SRCCOPY|CAPTUREBLT);
	::ReleaseDC(0, scr_dc);
	::SelectClipRgn(ImgDc, NULL);
	::DeleteObject(hWrgn);
	::DeleteDC(scr_dc);

	DispInfo();
}

//---------------------------------------------------------------------------
void __fastcall TCapStickForm::Timer1Timer(TObject *Sender)
{
	CopyBtn->Enabled = !ImgBuff->Empty;
	SaveBtn->Enabled = !ImgBuff->Empty;

	if (Capturing) {
		//}EXʒũEBhE擾
		POINT p;
		::GetCursorPos(&p);
		HWND hPosWnd = ::WindowFromPoint(p);
		//Lv`[
		if (hCurWnd!=hPosWnd) {
			hCurWnd = hPosWnd;
			CaptWndImg(hCurWnd);
			if (!SoundChgImg.IsEmpty()) ::sndPlaySound(SoundChgImg.c_str(), SND_ASYNC);
		}
		//}EXʒũsNZF擾
		if (ColValFmt>0) {
			HDC scr_dc = ::GetDC(0);
			COLORREF c = ::GetPixel(scr_dc, p.x, p.y);
			::ReleaseDC(0, scr_dc);
			ColPanel->Color = (TColor)c;
			int r = GetRValue(c);
			int g = GetGValue(c);
			int b = GetBValue(c);
			UnicodeString colstr;
			switch (ColValFmt) {
			case 1: colstr.sprintf(_T("%3d,%3d,%3d"), r,g,b);  break;
			case 2: colstr.sprintf(_T("0x%08x"),c); 		   break;
			case 3: colstr.sprintf(_T("#%02x%02x%02x"),r,g,b); break;
			}
			ColValEdit->Text = colstr;
		}
	}
}

//---------------------------------------------------------------------------
//Lv`[[hɓ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CapToolImgMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (!Capturing && Button==mbLeft) {
		//obt@j
		ImgBuff->Handle = NULL;
		SelRect = Rect(0,0,0,0);
		SetSelRect();

		//}EXJ[\ύX
		Screen->Cursor = crCapture;
		MrkImageList->GetBitmap(0, CapToolImg->Picture->Bitmap);
		CapToolImg->Repaint();
		Capturing = true;
	}
}
//---------------------------------------------------------------------------
//Lv`[[h甲
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CapToolImgMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (!Capturing) return;

	//mOEFCg
	if (Shift.Contains(ssCtrl)) {
		if (CaptureWait>0) {
			WaitTimeBar->Visible = true;
			MrkImageList->GetBitmap(2, CapToolImg->Picture->Bitmap);
			CapToolImg->Repaint();
			int start_cnt = GetTickCount();
			for (;;) {
				int r = CaptureWait - (GetTickCount() - start_cnt);
				if (r<=0) break;
				WaitTimeBar->Position = (int)(WaitTimeBar->Max * r/CaptureWait);
				Sleep(500);
			}
			WaitTimeBar->Visible = false;
		}
	}

	//}EXʒũEBhE擾
	POINT p = Point(X,Y);
	::GetCursorPos(&p);
	hCurWnd = ::WindowFromPoint(p);

	if (Button==mbLeft) {
		//Ώۂ(̈ꕔ)łȂΈUBčēxLv`[
		RECT rcx, rc;
		::GetWindowRect(hCurWnd, &rc);
		::IntersectRect(&rcx, &BoundsRect, &rc);
		if (!EqualRect(&rcx, &rc)) {
			Visible = false;
			Sleep(HideWait);
			CaptWndImg(hCurWnd);
			Visible = true;
		}
		ImgBuff->Assign(Image1->Picture->Bitmap);
		SelRect = Rect(0,0,0,0);
		SetSelRect();
		Capturing = false;

		//J[\c[o[̈ʒu֌Ăі߂
		Screen->Cursor = crDefault;
		MrkImageList->GetBitmap(1, CapToolImg->Picture->Bitmap);
		CapToolImg->Repaint();
		p = ToolPanel->ClientToScreen(Point(ToolBar1->Width+16,ToolPanel->Height/2));
		::SetCursorPos(p.x, p.y);

		if (!SoundCapImg.IsEmpty()) ::sndPlaySound(SoundCapImg.c_str(), SND_ASYNC);
	}
}

//---------------------------------------------------------------------------
//J[\L[ɂIg̈ړATCYύX
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	switch (Key) {
	case VK_UP: case VK_DOWN: case VK_LEFT: case VK_RIGHT:
		//\tJ[\̈ړ
		if (CsrPasting) {
			TPoint p = Mouse->CursorPos;
			switch (Key) {
			case VK_UP:		p.y--; break;
			case VK_DOWN:	p.y++; break;
			case VK_LEFT:	p.x--; break;
			case VK_RIGHT:	p.x++; break;
			}
			Mouse->CursorPos = p;
			Key = 0;
		}
		//Ig
		else if (!Selecting && !SelMoving && !SelRect.IsEmpty()) {
			orgX = orgY = 0;
			//TCYύX
			if (Shift.Contains(ssCtrl)) {
				switch (Key) {
				case VK_UP:
					SelRect.Bottom--; break;
				case VK_DOWN:
					if (SelRect.Bottom<ImgBuff->Height) SelRect.Bottom++;
					break;
				case VK_LEFT:
					SelRect.Right--;  break;
				case VK_RIGHT:
					if (SelRect.Right<ImgBuff->Width)SelRect.Right++;
					break;
				}
				SetSelRect();
			}
			//ړ
			else {
				int dx = SelShape->Width;
				int dy = SelShape->Height;
				if (Shift.Contains(ssShift)) dx = dy = 1;
				SelMoving = true;
				switch (Key) {
				case VK_UP:		SelShapeMouseMove(NULL, Shift,  0,-dy); break;
				case VK_DOWN:	SelShapeMouseMove(NULL, Shift,  0, dy); break;
				case VK_LEFT:	SelShapeMouseMove(NULL, Shift,-dx,  0); break;
				case VK_RIGHT:	SelShapeMouseMove(NULL, Shift, dx,  0); break;
				}
				SelMoving = false;
				if ((SelShape->Top + SelShape->Height) > ScrollBox1->ClientHeight)
					ScrollBox1->VertScrollBar->Position += dy;
				else if (SelShape->Top<0)
					ScrollBox1->VertScrollBar->Position -= dy;
				DispInfo();
			}
			Key = 0;
		}
		break;
	}
}

//---------------------------------------------------------------------------
//Rs[
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CopyBtnClick(TObject *Sender)
{
	//Ig
	if (SelShape->Visible && !SelRect.IsEmpty()) {
		std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		int w = SelRect.Width();
		int h = SelRect.Height();
		bmp->SetSize(w, h);
		bmp->Canvas->CopyRect(Rect(0,0, w, h), ImgBuff->Canvas, SelRect);
		Clipboard()->Assign(bmp.get());
	}
	//S
	else
		Clipboard()->Assign(ImgBuff);

	if (!is_KeyDown(VK_SHIFT)) {
		HWND hw = get_hwnd_ex(
			CopyActWndClass.c_str(), CopyActWndTitle.c_str(), CopyActWndTitleR.c_str());

		if (hw) {
			if (::IsIconic(hw)) ::SendMessage(hw, WM_SYSCOMMAND, SC_RESTORE, 0);
			::SetForegroundWindow(hw);
		}
		else
			run_app_wait(CopyCmdLine, 30000);	//T.O. = 30b

		send_key_ex(CopySendKey, 50);
	}
}

//---------------------------------------------------------------------------
//ۑ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SaveBtnClick(TObject *Sender)
{
	bool doOnSave = !is_KeyDown(VK_SHIFT);

	SavePictureDialog1->Title = "摜ۑ";
	SavePictureDialog1->Filter = GraphicFilter(__classid(Graphics::TBitmap))
		+ "|JPEGt@C(*.JPG)|*.JPG|PNGt@C(*.PNG)|*.PNG|GIFt@C(*.GIF)|*.GIF|TIFt@C(*.TIF)|*.TIF";
	SavePictureDialog1->DefaultExt = LastDefExt;
	if		(LastDefExt.CompareIC("JPG")==0) SavePictureDialog1->FilterIndex = 2;
	else if (LastDefExt.CompareIC("PNG")==0) SavePictureDialog1->FilterIndex = 3;
	else if (LastDefExt.CompareIC("GIF")==0) SavePictureDialog1->FilterIndex = 4;
	else if (LastDefExt.CompareIC("TIF")==0) SavePictureDialog1->FilterIndex = 5;
	else									 SavePictureDialog1->FilterIndex = 1;
	SavePictureDialog1->InitialDir = LastDir;
	if (SavePictureDialog1->Execute()) {
		std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		if (SelShape->Visible && !SelRect.IsEmpty()) {
			int w = SelRect.Right  - SelRect.Left;
			int h = SelRect.Bottom - SelRect.Top;
			bmp->SetSize(w, h);
			bmp->Canvas->CopyRect(Rect(0,0, w, h), ImgBuff->Canvas, SelRect);
		}
		else
			bmp->Assign(ImgBuff);

		UnicodeString fnam = SavePictureDialog1->FileName;
		if (!WIC_save_image(fnam, bmp.get(), JpegQuality))
			msgbox_ERR("摜̕ۑɎs܂B");

		LastDefExt = ExtractFileExt(fnam).UpperCase();
		LastDir    = ExtractFileDir(fnam);

		if (doOnSave) {
			UnicodeString cmdline = SaveCmdLine;
			int p = fnam.Pos(" "); if (p>0) fnam = "\""+fnam+"\"";
			p = cmdline.Pos("$F");
			if (p>0)
				cmdline = ReplaceStr(cmdline, "$F", fnam);
			else
				cmdline += (" "+fnam);
			run_app_wait(cmdline);
		}
	}
}

//---------------------------------------------------------------------------
//j[\
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ActionList1Update(TBasicAction *Action, bool &Handled)
{
	ChgSizeItem->Enabled  = !ImgBuff->Empty;
	ColorItem->Enabled	  = !ImgBuff->Empty;
	ImageItem->Enabled	  = !ImgBuff->Empty;
	MouseCsrItem->Enabled = !ImgBuff->Empty;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowMenu(TObject *Sender)
{
	TPoint p;
	if (dynamic_cast<TToolButton *>(Sender) != NULL) {
		p = ToolBar1->ClientToScreen(Point(MenuBtn->Left+16, 16));
		ShowItem->Visible	= true;
		OptionItem->Visible = true;
		AboutItem->Visible	= true;
	}
	else {
		p = Mouse->CursorPos;
		ShowItem->Visible	= false;
		OptionItem->Visible = false;
		AboutItem->Visible	= false;
	}
	PopupMenu1->OwnerDraw = true;
	PopupMenu1->Popup(p.x, p.y);
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::MouseCsrItemClick(TObject *Sender)
{
	PopupMenu1->OwnerDraw = true;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowItemClick(TObject *Sender)
{
	PopupMenu1->OwnerDraw = false;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::AboutItemClick(TObject *Sender)
{
	PopupMenu1->OwnerDraw = true;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::PopMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	//𒲐
	if (((TComponent *)Sender)->Tag>1000) {
		int wd = 44+ACanvas->TextWidth(" Version 0.00");
		if (wd>Width) Width = wd;
	}
	else
		Width += 8;
	//𒲐
	Height += 2;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::MouseCsrItemDrawItem(TObject *Sender,
    TCanvas *ACanvas, const TRect &ARect, bool Selected)
{
	ACanvas->Brush->Color = Selected ? clHighlight : clMenu;
	ACanvas->FillRect(ARect);
	::DrawIcon(ACanvas->Handle, ARect.Left+8, ARect.Top+2, Screen->Cursors[((TComponent *)Sender)->Tag]);
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::MouseCsrItemMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	Height = 36;
	Width  = 40;
}

//---------------------------------------------------------------------------
//o[W`
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::AbautItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, TRect &ARect, bool Selected)
{
	TMenuItem *tp =(TMenuItem*)Sender;
	ACanvas->Brush->Color = clBlack;
	ACanvas->FillRect(ARect);
	RECT rc = RECT(ARect);
	TFontStyles fstyle;

	switch (tp->Tag) {
	case 1001:	//㔼
		ACanvas->Draw(ARect.Left+4, ARect.Bottom-16, Application->Icon);
		fstyle.Clear(); fstyle<<fsBold;
		ACanvas->Font->Style = fstyle;
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left+44, ARect.Top+2, "CapStick");
		::DrawEdge(ACanvas->Handle, &rc, BDR_SUNKENOUTER, BF_TOP|BF_LEFT|BF_RIGHT);
		break;
	case 1002:	//
		ACanvas->Draw(ARect.Left+4, ARect.Top-16, Application->Icon);
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left+48, ARect.Top+2,
			"Version "+FloatToStrF(VersionNo/100.0, ffFixed,4,2));
		::DrawEdge(ACanvas->Handle, &rc, BDR_SUNKENOUTER, BF_BOTTOM|BF_LEFT|BF_RIGHT);
		break;
	}
}

//---------------------------------------------------------------------------
//TCYύX
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ResizeActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	AddUndo();
	int w = ImgBuff->Width;
	int h = ImgBuff->Height;

	switch (((TAction *)Sender)->Tag) {
	case  25: w/=4;    h/=4;	break;
	case  50: w/=2;    h/=2;	break;
	case  75: w=w*3/4; h=h*3/4; break;
	case 150: w=w*3/2; h=h*3/2; break;
	case 200: w*=2;    h*=2;	break;
	}

	std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
	bmp->Assign(ImgBuff);
	WIC_resize_image(bmp.get(), ImgBuff, 0.0, w, h, ScaleOpt);
	DrawImgBuff();
	SelRect = Rect(0,0,0,0);
	SetSelRect();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ResizeActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}
//---------------------------------------------------------------------------
//ȈՌF
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ReduceActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	ToolPanel->Repaint();

	AddUndo();
	ImgBuff->Assign(Image1->Picture->Bitmap);

	switch (((TAction *)Sender)->Tag) {
	case   2:	//mN 2F
		ImgBuff->PixelFormat = pf1bit;
		break;
	case  16:	//16F
		ImgBuff->PixelFormat = pf4bit;
		break;
	case 256:	//256F
		{
			std::unique_ptr<TJPEGImage> jpgimg(new TJPEGImage());
			jpgimg->Assign(Image1->Picture->Bitmap);
			jpgimg->Compress();
			jpgimg->PixelFormat = jf8Bit;
			ImgBuff->Assign(jpgimg.get());
		}
		break;
	case  -2:	//O[XP[
		WIC_grayscale_image(ImgBuff);
	    break;
	}

	DrawImgBuff();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ReduceActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	TPixelFormat pf = ImgBuff->PixelFormat;
	switch (ap->Tag) {
	case   2:	//mN 2F
		ap->Enabled = (pf!=pf1bit);	break;
	case  16:	//16F
		ap->Enabled = (pf!=pf1bit && pf!=pf4bit);	break;
	case 256:	//256F
	case  -2:	//O[XP[
		ap->Enabled = (pf!=pf1bit && pf!=pf4bit && pf!=pf8bit);	break;
	}
}

//---------------------------------------------------------------------------
//ZsA
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SepiaActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	ToolPanel->Repaint();
	AddUndo();
	ImgBuff->PixelFormat = pf24bit;
	double V = -0.10;
	double U =  0.05;
	int n0 = 1.4026*V*255;
	int n1 = 0.3444*U*255 + 0.7114*V*255;
	int n2 = 1.7330*U*255;
	int n;
	for (int j = 0; j<ImgBuff->Height; j++) {
		BYTE *p = (BYTE*)ImgBuff->ScanLine[j];
		for (int i=0; i<ImgBuff->Width; i++,p+=3) {
	        int Y = (p[0]*114 + p[1]*587 + p[2]*299)/1000;
			n = Y + n0;	if (n>255) n=255; else if (n<0) n=0;
			p[0] = (BYTE)n;	//B
			n = Y - n1; if (n>255) n=255; else if (n<0) n=0;
			p[1] = (BYTE)n;	//G
			n = Y + n2; if (n>255) n=255; else if (n<0) n=0;
			p[2] = (BYTE)n;	//R
		}
	}

	DrawImgBuff();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SepiaActionUpdate(TObject *Sender)
{
	TPixelFormat pf = ImgBuff->PixelFormat;
	((TAction *)Sender)->Enabled = (pf!=pf1bit && pf!=pf4bit && pf!=pf8bit);
}

//---------------------------------------------------------------------------
//lK|W]
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::NegColActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	ToolPanel->Repaint();
	AddUndo();
	Image1->Canvas->CopyMode = cmNotSrcCopy;
	Image1->Canvas->Draw(0,0, Image1->Picture->Bitmap);
	Image1->Canvas->CopyMode = cmSrcCopy;
	if (ImgBuff->Palette==0)
		ImgBuff->Assign(Image1->Picture->Bitmap);
	else
		ImgBuff->Canvas->Draw(0,0, Image1->Picture->Bitmap);
	DispInfo();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::NegColActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}

//---------------------------------------------------------------------------
//UCN
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::MosicIActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;
	int msize = ((TAction *)Sender)->Tag;	if (msize<1) return;

	Screen->Cursor = crHourGlass;
	ToolPanel->Repaint();
	AddUndo();

	TRect m_rc;	//Ώ۔͈
	if (SelShape->Visible && !SelRect.IsEmpty())
		m_rc = SelRect;
	else
		m_rc = Rect(0,0, ImgBuff->Width,ImgBuff->Height);
	int b_w = m_rc.Width()/msize;
	int b_h = m_rc.Height()/msize;

	std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
	bmp->Assign(Image1->Picture->Bitmap);
	bmp->PixelFormat = pf24bit;

	for (int by = 0; by<=b_h; by++) {
		int yp = by*msize + m_rc.Top;
		for (int bx = 0; bx<=b_w; bx++) {
			int xp = bx * msize + m_rc.Left;
			//ubN̕ς߂
			int xR,xG,xB,cnt;
			xR = xG = xB = cnt = 0;
			for (int j=yp; j<yp+msize; j++) {
				if (j>=m_rc.Bottom) break;
				BYTE *p = (BYTE*)bmp->ScanLine[j];
				p += (xp*3);
				for (int i=xp; i<xp+msize; i++,p+=3) {
					if (i>=m_rc.Right) continue;
					xB += p[0];  xG += p[1];  xR += p[2];
					cnt++;
				}
			}
			if (cnt==0) continue;
			xR /= cnt;  xG /= cnt;  xB /= cnt;

			//ubNhׂ
			for (int j=yp; j<yp+msize; j++) {
				if (j>=m_rc.Bottom)  break;
				BYTE *p = (BYTE*)bmp->ScanLine[j];
				p += (xp*3);
				for (int i=xp; i<xp+msize; i++,p+=3) {
					if (i>=m_rc.Right) continue;
					p[0] = (BYTE)xB;
					p[1] = (BYTE)xG;
					p[2] = (BYTE)xR;
				}
			}
		}
	}

	if (ImgBuff->Palette==0)
		ImgBuff->Assign(bmp.get());
	else
		ImgBuff->Canvas->Draw(0,0, bmp.get());
	DrawImgBuff();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::MosicIActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}
//---------------------------------------------------------------------------
//XO]
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::RotateActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	ToolPanel->Repaint();
	AddUndo();

	int w = ImgBuff->Width;
	int h = ImgBuff->Height;

	std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
	bmp->Assign(Image1->Picture->Bitmap);
	WIC_rotate_image(bmp.get(), (((TAction *)Sender)->Tag==0)? 1 : 3);
	if (ImgBuff->Palette==0)
		ImgBuff->Assign(bmp.get());
	else {
		ImgBuff->SetSize(w, h);
		ImgBuff->Canvas->Draw(0,0, bmp.get());
	}
	DrawImgBuff();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::RotateActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}
//---------------------------------------------------------------------------
//]
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ReverseActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;

	AddUndo();
	WIC_rotate_image(ImgBuff, (((TAction *)Sender)->Tag==0)? 4 : 5);
	Image1->Canvas->Draw(0,0, ImgBuff);
	DispInfo();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ReverseActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}

//---------------------------------------------------------------------------
//}EXJ[\\t
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CsrPasteItemClick(TObject *Sender)
{
	Screen->Cursor = (TCursor)((TComponent *)Sender)->Tag;

	//}EXJ[\̈ړ͈͂𐧌
	TRect rc = ScrollBox1->ClientRect;
	rc.SetLocation(ScrollBox1->ClientToScreen(rc.Location));
	::ClipCursor(&rc);

	SelRect = Rect(0,0,0,0);
	SetSelRect();

	StatusBar1->SimpleText = "}EXJ[\\t...";
	CsrPasting = true;
}

//---------------------------------------------------------------------------
void __fastcall TCapStickForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (ImgBuff->Empty) return;
	if (CsrPasting) {
		//}EXJ[\\t
		if (X<=ImgBuff->Width && Y<=ImgBuff->Height && Button==mbLeft) {
			AddUndo();
			//zbgX|bg擾
			int hx = 0, hy = 0;
			ICONINFO ii;
			if (::GetIconInfo(Screen->Cursors[Screen->Cursor], &ii)) {
				hx = ii.xHotspot;
				hy = ii.yHotspot;
				if (ii.hbmMask)  ::DeleteObject(ii.hbmMask);
				if (ii.hbmColor) ::DeleteObject(ii.hbmColor);
			}
			//\t
			::DrawIcon(Image1->Canvas->Handle, X-hx, Y-hy, Screen->Cursors[Screen->Cursor]);
			ImgBuff->Assign(Image1->Picture->Bitmap);
			DrawImgBuff();
		}
		::ClipCursor(NULL);
		Screen->Cursor = crDefault;
		CsrPasting = false;
	}
	else {
		if (Button==mbLeft) {
			if (X<=ImgBuff->Width && Y<=ImgBuff->Height) {
				//}EXJ[\̈ړ͈͂𐧌
				TRect rc = ScrollBox1->ClientRect;
				rc.Right++; rc.Bottom++;
				rc.SetLocation(ScrollBox1->ClientToScreen(rc.Location));
				::ClipCursor(&rc);

				//Ig̏AIJn
				SelRect   = Rect(X,Y,X,Y);
				orgX	  = X;
				orgY	  = Y;
				SetSelRect();
				Selecting = true;
			}
		}
		//ENbNj[
		else if (Button==mbRight)
			ShowMenu(ScrollBox1);
	}
}

//---------------------------------------------------------------------------
//gI
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	if (Selecting) {
		if (X>ImgBuff->Width)  X = ImgBuff->Width;
		if (Y>ImgBuff->Height) Y = ImgBuff->Height;
		if (X-orgX<0) {
			SelRect.Left  = X;
			SelRect.Right = orgX;
		}
		else {
			SelRect.Left  = orgX;
			SelRect.Right = X;
		}
		if (Y-orgY<0) {
			SelRect.Top	   = Y;
			SelRect.Bottom = orgY;
		}
		else {
			SelRect.Top	   = orgY;
			SelRect.Bottom = Y;
		}
		SetSelRect();
	}
}
//---------------------------------------------------------------------------
//gII
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	//}EXJ[\ړ͈͐
	::ClipCursor(NULL);

	Selecting = false;
	DispInfo();
}
//---------------------------------------------------------------------------
//IgNbN
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SelShapeMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	//ENbNj[
	if (Button==mbRight)
		ShowMenu(Sender);
	//IgړJn
	else {
		if (ImgBuff->Empty) return;
		SelMoving = true;
		Screen->Cursor = crSizeAll;
		orgX = X;
		orgY = Y;
		DispInfo();
	}
}
//---------------------------------------------------------------------------
//Igړ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SelShapeMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	if (SelMoving) {
		//ړ
		SelRect.Offset((X - orgX),(Y - orgY));
		if (SelRect.Left<0) SelRect.Offset(-SelRect.Left, 0);
		if (SelRect.Top<0)  SelRect.Offset(0, -SelRect.Top);
		//Eړ
		int w = ImgBuff->Width;
		int h = ImgBuff->Height;
		if (SelRect.Right>w)  SelRect.Offset(w-SelRect.Right, 0);
		if (SelRect.Bottom>h) SelRect.Offset(0, h-SelRect.Bottom);

		SetSelRect();
	}
}
//---------------------------------------------------------------------------
//IgړI
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::SelShapeMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	SelMoving = false;
	Screen->Cursor = crDefault;
	DispInfo();
}

//---------------------------------------------------------------------------
//g~O
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::TrimActionExecute(TObject *Sender)
{
	if (ImgBuff->Empty) return;
	if (!SelShape->Visible || SelRect.IsEmpty()) return;

	AddUndo();
	int w = SelRect.Width();
	int h = SelRect.Height();

	std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
	bmp->Assign(ImgBuff);
	ImgBuff->SetSize(w, h);
	ImgBuff->Canvas->CopyRect(Rect(0,0, w, h), bmp->Canvas, SelRect);
	SelShape->Visible = false;
	DrawImgBuff();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::TrimActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = SelShape->Visible && !SelRect.IsEmpty();
}

//---------------------------------------------------------------------------
//AhD
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::UndoActionExecute(TObject *Sender)
{
	Graphics::TBitmap *bp = (Graphics::TBitmap *)UndoList->Objects[0];
	ImgBuff->Assign(bp);
	delete bp;
	UndoList->Delete(0);

	DrawImgBuff();
	if (!SelRect.IsEmpty()) SelShape->Visible = true;
	DispInfo();
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::UndoActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = (UndoList->Count>0);
}
//---------------------------------------------------------------------------
//EBhENX̕\؂ւ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowClassActionExecute(TObject *Sender)
{
	ClsNamPanel->Visible= !ClsNamPanel->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowClassActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Checked = ClsNamPanel->Visible;
}
//---------------------------------------------------------------------------
//EBhEeLXg̕\؂ւ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowTextActionExecute(TObject *Sender)
{
	WndTxtPanel->Visible = !WndTxtPanel->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowTextActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Checked = WndTxtPanel->Visible;
}
//---------------------------------------------------------------------------
//ʒũsNZF擾 \؂ւ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CapColItemClick(TObject *Sender)
{
	ColFmt0Item->Checked = (ColValFmt==0);
	ColFmt1Item->Checked = (ColValFmt==1);
	ColFmt2Item->Checked = (ColValFmt==2);
	ColFmt3Item->Checked = (ColValFmt==3);
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ColFmtItemClick(TObject *Sender)
{
	ColValFmt = ((TComponent *)Sender)->Tag;
	PixColPanel->Visible = (ColValFmt>0);
}

//---------------------------------------------------------------------------
//Xe[^Xo[̕\؂ւ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowSttBarActionExecute(TObject *Sender)
{
	StatusBar1->Visible = !StatusBar1->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::ShowSttBarActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Checked = StatusBar1->Visible;
}
//---------------------------------------------------------------------------
//wiFw
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::BgColItemClick(TObject *Sender)
{
	ColorDialog1->Color = ImgBgCol;
	if (ColorDialog1->Execute()) {
		ImgBgCol = ColorDialog1->Color;
		ScrollBox1->Color = ImgBgCol;
		Image1->Canvas->Brush->Color = ImgBgCol;
		Image1->Canvas->FillRect(Image1->ClientRect);
		ImgBuff->Handle = NULL;
	}
}

//---------------------------------------------------------------------------
//IvVݒ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::OptionItemClick(TObject *Sender)
{
	OptionDlg->ShowModal();
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::HelpItemClick(TObject *Sender)
{
	Application->HelpShowTableOfContents();
}
//---------------------------------------------------------------------------
//Weby[WJ
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::GoWebItemClick(TObject *Sender)
{
	::ShellExecute(NULL, _T("open"), SUPPORT_URL,NULL,NULL,SW_SHOWNORMAL);
}

//---------------------------------------------------------------------------
//BLZ{^
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::CanButtonClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
//t@CJ[\\t
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::LoadCsrActionExecute(TObject *Sender)
{
	OpenDialog1->Title		= "J[\̓\t";
	OpenDialog1->Filter 	= "*.cur;*.ani";
	OpenDialog1->DefaultExt = "CUR";
	OpenDialog1->InitialDir = LastCurDir;
	OpenDialog1->FileName	= "*.cur";
	if (OpenDialog1->Execute()) {
		HCURSOR hCur = ::LoadCursorFromFile(OpenDialog1->FileName.c_str());
		if (hCur) {
			LastCurDir = ExtractFileDir(OpenDialog1->FileName);
			Screen->Cursors[crPaste] = hCur;
			Screen->Cursor = crPaste;

			//}EXJ[\̈ړ͈͂𐧌
			TRect rc = ScrollBox1->ClientRect;
			rc.SetLocation(ScrollBox1->ClientToScreen(rc.Location));
			::ClipCursor(&rc);

			SelRect = Rect(0,0,0,0);
			SetSelRect();

			StatusBar1->SimpleText = "}EXJ[\\t...";
			CsrPasting = true;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TCapStickForm::LoadCsrActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !ImgBuff->Empty;
}
//---------------------------------------------------------------------------

